<template>
  <div class="row">
    <div class="col-md-8">
      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label>Cliente</label>
            <select class="form-control" v-model="client">
              <option :value="null">Seleccione</option>
              <option
                :value="prod.id"
                v-for="(prod, p) in items.clientes"
                :key="p + '_P_'"
              >
                {{ prod.name }} {{ prod.last_name }}
              </option>
            </select>
          </div>
        </div>
      </div>
    </div>
    <div
      class="col-md-12 justify-content-center"
      v-for="(item, idx) in form"
      :key="idx"
    >
      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label>Producto</label>
            <select class="form-control" v-model="item.product">
              <option :value="null">Seleccione</option>
              <option
                :value="prod.id"
                v-for="(prod, p) in items.productos"
                :key="p + '_P_'"
              >
                {{ prod.name }}
              </option>
            </select>
          </div>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>Cantidad</label>
            <input
              type="number"
              min="1"
              v-model="item.quantity"
              class="form-control"
            />
          </div>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>Observación</label>
            <input
              type="text"
              v-model="item.observation"
              class="form-control"
            />
          </div>
        </div>
      </div>
    </div>

    <div class="col-md-8 d-flex">
      <div class="form-group">
        <button class="btn btn-outline-primary" @click="addProduct()">
          <i class="lni-plus"></i>
        </button>
      </div>
      <transition name="fade">
        <div class="form-group ml-2" v-if="form.length != 1">
          <button class="btn btn-outline-danger" @click="deleteProduct()">
            <i class="lni-minus"></i>
          </button>
        </div>
      </transition>
    </div>
    <div class="col-md-8 d-flex">
      <transition name="fade">
        <div class="form-group" v-if="form[0].product">
          <button class="btn btn-success" @click="createInvoice()">
            <i class="lni-check-mark-circle text-white"></i>
            {{ isLoading ? "Cargando..." : "Confirmar" }}
          </button>
        </div>
      </transition>
    </div>
  </div>
</template>
<style>
.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter,
.fade-leave-to {
  opacity: 0;
}
</style>
<script lang="ts">
import axios from "axios";
import Swal from "sweetalert2";
import Vue from "vue";
import { mapGetters } from "vuex";
export default Vue.extend({
  data() {
    return {
      isLoading: false,
      items: [],
      client: null,
      form: [
        {
          product: "",
          observation: "",
          quantity: "1",
        },
      ],
    };
  },
  mounted() {
    this.loadGeneralInformation();
  },
  computed: {
    ...mapGetters({
      user: "getUser",
    }),
  },
  methods: {
    loadGeneralInformation(): void {
      axios.get("general-lists").then((res) => {
        this.items = res.data;
      });
    },
    addProduct(): void {
      if (this.form.length == 1) {
        const data = this.form[0];
        if (data.product == "") {
          alert("Debe completar los datos del primer producto");
        } else {
          this.form.push({
            product: "",
            observation: "",
            quantity: "1",
          });
        }
      } else {
        const last = this.form[this.form.length - 1];
        if (last.product == "") {
          alert("Complete el campo anterior");
        } else {
          this.form.push({
            product: "",
            observation: "",
            quantity: "1",
          });
        }
      }
    },
    deleteProduct(): void {
      if (this.form.length > 1) {
        this.form.splice(this.form.length - 1, 1);
      }
    },
    createInvoice(): void {
      if (this.client == null) {
        alert("Debe seleccionar un cliente para poder realizar la operación");
      } else {
        // validación cuando se repiten productos para enviar un solo producto con la suma
        const cart = this.form.reduce((acumulator: any, valorActual) => {
          const isExist = acumulator.find(
            (element) => element.product === valorActual.product
          );
          if (isExist) {
            return acumulator.map((element) => {
              let x = 0;
              if (element.product === valorActual.product) {
                element.quantity = parseInt(element.quantity);
                x = parseInt(valorActual.quantity) + parseInt(element.quantity);
                return {
                  ...element,
                  quantity: x,
                };
              }

              return element;
            });
          }

          return [...acumulator, valorActual];
        }, []);
        cart.map((el) => {
          el.quantity = parseInt(el.quantity);
        });

        this.isLoading = true;
        axios
          .post("invoice", {
            products: cart,
            client: this.client,
            created_user: this.user[0].name,
          })
          .then((res) => {
            if (res.data.message == "success") {
              Swal.fire({
                title: "Información",
                icon: "success",
                text: "Se ha registrado correctamente",
              });
              this.form = [
                {
                  product: "",
                  observation: "",
                  quantity: "1",
                },
              ];
            } else {
              Swal.fire({
                title: "Información",
                icon: "error",
                text: res.data.error,
              });
            }
            this.isLoading = false;
          });
      }
    },
  },
});
</script>
